SystemOrganization addCategory: #'Websela-Bootstrap'!
SystemOrganization addCategory: #'Websela-Bootstrap-Tests'!

!WebRequest methodsFor: '*websela' stamp: 'SvenVanCaekenberghe 6/28/2010 17:12'!
sendBadRequest
	^ self sendResponseCode: 400! !

!WebRequest methodsFor: '*websela' stamp: 'SvenVanCaekenberghe 6/28/2010 17:09'!
sendCreated
	^ self sendCreated: self rawUrl ! !

!WebRequest methodsFor: '*websela' stamp: 'SvenVanCaekenberghe 6/28/2010 17:11'!
sendCreated: url
	^ self 
		sendResponseCode: 201
		contents: 'Successfully created URL ', url
		do: [ :response | response headerAt: 'Location' put: url ]! !

!WebRequest methodsFor: '*websela' stamp: 'SvenVanCaekenberghe 6/28/2010 17:13'!
sendNotAcceptable
	^ self sendResponseCode: 406! !

!WebRequest methodsFor: '*websela' stamp: 'SvenVanCaekenberghe 6/28/2010 17:18'!
sendNotFound
	^ self sendNotFound: self rawUrl ! !

!WebRequest methodsFor: '*websela' stamp: 'SvenVanCaekenberghe 6/28/2010 19:39'!
sendNotFound: url
	^ self 
		sendResponseCode: 404
		contents: 'The requested URL ', url, ' was not found on this server'! !

!WebRequest methodsFor: '*websela' stamp: 'SvenVanCaekenberghe 6/28/2010 16:55'!
sendResponseCode: code
	^ self sendResponseCode: code contents: nil do: nil! !

!WebRequest methodsFor: '*websela' stamp: 'SvenVanCaekenberghe 6/28/2010 16:55'!
sendResponseCode: code contents: string
	^ self sendResponseCode: code contents: string do: nil! !

!WebRequest methodsFor: '*websela' stamp: 'SvenVanCaekenberghe 6/28/2010 18:18'!
sendResponseCode: code contents: string do: block
	"Send a response based on a numeric HTTP status code, optionally add an extra string, 
	or use a block to customize the response, for example its headers" 
	
	| response body |
	response := self newResponse protocol: 'HTTP/1.1' code: code.
	response headerAt: 'Content-Type' put: 'text/html'.
	block ifNotNil: [ block value: response ].
	body := String streamContents: [ :str |
		str nextPutAll: '<html><head><title>'; nextPutAll: response status; nextPutAll: '</title></head>'.
		str nextPutAll: '<body><h1>', response status, '</h1>'.
		string ifNotNil: [ str nextPutAll: '<p>'; nextPutAll: string; nextPutAll: '</p>' ].
		str nextPutAll: '</body></html>' ].
	^ self sendResponse: response content: body! !

!WebRequest methodsFor: '*websela' stamp: 'SvenVanCaekenberghe 6/28/2010 16:56'!
sendResponseCode: code do: block
	^ self sendResponseCode: code contents: nil do: block! !

TestCase subclass: #WBBootstrapTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Websela-Bootstrap-Tests'!

!WBBootstrapTest methodsFor: 'as yet unclassified' stamp: 'chc 12/6/2013 20:00'!
setUp! !

!WBBootstrapTest methodsFor: 'as yet unclassified' stamp: 'chc 12/6/2013 20:01'!
testOnStartUpList

	self assert: ((SmalltalkImage classPool at: #StartUpList) includes: #WBBootstrap)
! !

!WAWebServerAdaptor methodsFor: '*websela-boostrap' stamp: 'chc 11/27/2013 15:07'!
server
	^server! !

!WAWebServerAdaptor methodsFor: '*websela-boostrap' stamp: 'chc 11/27/2013 15:07'!
server: anObject
	server := anObject! !

WAWebServerAdaptor subclass: #WBBootstrap
	instanceVariableNames: 'directory isAuthenticated'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Websela-Bootstrap'!

!WBBootstrap class methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/22/2010 11:22'!
default
	Default ifNil: [ Default := self new ].
	^ Default! !

!WBBootstrap class methodsFor: 'accessing' stamp: 'chc 5/18/2013 12:06'!
initialize
	"MCWebServer initialize"
	Smalltalk addToStartUpList: self.  ! !

!WBBootstrap class methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/22/2010 12:08'!
reset
	Default ifNotNil: [ Default destroy. Default := nil ].! !

!WBBootstrap class methodsFor: 'accessing' stamp: 'chc 12/9/2013 15:00'!
startUp
	| adap port passwd username application |
"get parameters from the command line"
	Smalltalk extractParameters	
	at: 'PORT' ifPresent: [ :value | value isEmptyOrNil ifFalse: [ port := value asInteger ] ];
	at: 'PASSWD' ifPresent: [ :value | value isEmptyOrNil ifFalse: [ passwd := value ] ];
	at: 'USERNAME' ifPresent: [ :value | value isEmptyOrNil ifFalse: [ username := value  ] ].
"start the server for Seaside"
	adap := WBBootstrap port: port.
	adap basicStart.
	adap directory: FileDirectory default.
	adap server passwordAt: username realm: adap realm  put: passwd.
"set the config page u/p for Seaside"
	application := WADispatcher default handlerAt: 'config'.
	application configuration 
      addParent: WAAuthConfiguration instance.
	application
 		       preferenceAt: #login put: username;
   			 preferenceAt: #passwordHash put: (GRPlatform current secureHashFor: passwd).
	application addFilter: WAAuthenticationFilter new.! !

!WBBootstrap methodsFor: 'accessing' stamp: 'chc 11/28/2013 15:11'!
addUser: user withPassword: password
	self isAuthenticated: true.
	self server
		passwordAt: user 
		realm: self realm
		put: password ! !

!WBBootstrap methodsFor: 'private' stamp: 'chc 12/6/2013 15:46'!
basicStart
	"Start the WebServer instance"
	server := WebServer new.
	server addService: '/' action: [ :request | self handleWebRequest: request ]
		methods: #(GET PUT).
	server certName: certName.
	server listenOn: self port.! !

!WBBootstrap methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 6/22/2010 11:28'!
destroy
	self webServer destroy ! !

!WBBootstrap methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/22/2010 11:27'!
directory
	^ directory! !

!WBBootstrap methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/22/2010 14:44'!
directory: aFileDirectory
	directory := aFileDirectory! !

!WBBootstrap methodsFor: 'private' stamp: 'chc 12/9/2013 16:09'!
dispatchWebRequest: request
	request isGetRequest ifTrue: [
			self process: request
		 ].
	request isPutRequest ifTrue: [
		^ self handlePutMczEntry: request
		 ]! !

!WBBootstrap methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/28/2010 19:39'!
handleGetMczEntry: request
	| name |
	name := request url allButFirst.
	((self isValidMczName: name) and: [ self directory fileExists: name ]) 
		ifTrue: [
			self directory readOnlyFileNamed: name do: [ :file | | response |
				file binary.
				response := request newResponse protocol: 'HTTP/1.1' code: 200.
				response headerAt: 'Content-Type' put: 'application/octet-stream'.
				request sendResponse: response contentStream: file size: file size.] ]
		ifFalse: [ request sendNotFound ]! !

!WBBootstrap methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/28/2010 19:25'!
handleListMczEntries: request
	request send200Response: self repositoryListing contentType: 'text/html'! !

!WBBootstrap methodsFor: 'private' stamp: 'chc 11/27/2013 15:56'!
handlePutMczEntry: request
	| name |
	name := request url allButFirst.
	((self isValidMczName: name) and: [ (self directory fileExists: name) not ]) 
		ifTrue: [
			self directory newFileNamed: name do: [ :file | 
				file binary.
				request streamFrom: request stream to: file size: request contentLength progress: nil.
				request sendCreated.
				"MczInstaller installFileNamed: file name" ] ]
		ifFalse: [ request sendBadRequest ]! !

!WBBootstrap methodsFor: 'private' stamp: 'chc 12/9/2013 15:27'!
handleWebRequest: request
	request isPutRequest
		ifTrue: [ self server
			authenticate: request 
			realm: self realm 
			methods: #(basic) 
			do: [ self dispatchWebRequest: request ] ]
		ifFalse: [ self dispatchWebRequest: request  ]! !

!WBBootstrap methodsFor: 'initialize-release' stamp: 'chc 12/9/2013 16:03'!
initialize 
	super initialize.
	self server: WebServer new.
	self isAuthenticated: false.
	self directory: FileDirectory default.
	self server
		addService: '/'
		action: [ :request | self handleWebRequest: request ]
		methods: #(GET PUT)
! !

!WBBootstrap methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/22/2010 14:18'!
isAuthenticated
	^ isAuthenticated! !

!WBBootstrap methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/22/2010 14:45'!
isAuthenticated: aBoolean
	isAuthenticated := aBoolean! !

!WBBootstrap methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/22/2010 13:51'!
isValidMczName: string
	^ string isString 
		and: [ string isEmpty not
			and: [ (string endsWith: '.mcz')
				and: [ (string includes: $/) not ] ] ]! !

!WBBootstrap methodsFor: 'initialize-release' stamp: 'chc 5/19/2013 12:01'!
listenOn: port
	self server listenOn: port! !

!WBBootstrap methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/22/2010 12:53'!
mczEntries
	^ (self directory fileNames select: [ :each | each endsWith: '.mcz' ])
		asSortedCollection! !

!WBBootstrap methodsFor: 'accessing' stamp: 'chc 11/26/2013 14:27'!
realm
	^ 'Websela'! !

!WBBootstrap methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/22/2010 12:42'!
repositoryListing
	^ String streamContents: [ :str |
		str nextPutAll: '<html><head><title>'; nextPutAll: self realm; nextPutAll: '</title></head>'.
		str nextPutAll: '<body><h1>'; nextPutAll: self realm; nextPutAll: '</h1>'.
		str nextPutAll: '<ul>'.
		self mczEntries do: [ :each | 
			str nextPutAll: '<li><a href="'; nextPutAll: each; nextPutAll: '">'; nextPutAll: each; nextPutAll: '</a></li>'].
		str nextPutAll: '</ul></body></html>' ]! !
WBBootstrap initialize!
